/*                     __                                               *\
**     ________ ___   / /  ___     Scala API                            **
**    / __/ __// _ | / /  / _ |    (c) 2003-2004, LAMP/EPFL             **
**  __\ \/ /__/ __ |/ /__/ __ |                                         **
** /____/\___/_/ |_/____/_/ | |                                         **
**                          |/                                          **
** $Id: Text.scala,v 1.20 2005/05/04 17:37:30 buraq Exp $
\*                                                                      */

package scala.xml;

/** an XML node for text (PCDATA). Used in both non-bound and bound XML 
 *  representations
 * @author Burak Emir
 * @param text the text contained in this node, may not be null.
 */
case class Text( _data: String ) extends Atom[String](_data) {  

  if(null == data)
    throw new java.lang.NullPointerException("tried to construct Text with null");

  /** @deprecated 
   */
  def text = data.toString();

  final override def equals(x:Any) = x match {
    case s:String  => s.equals( data.toString() );
    case s:Text    => data == s.data ;
    case _ => false;
  }

  /** returns text, with some characters escaped according to XML spec */
  override def toString(sb:StringBuffer) = 
    Utility.escape( data.toString(), sb );
    
}
